// Word Counter Widget
//copyright 2005 David Hanauer

window.onfocus = focus;
window.onblur = blur;

function focus() //to change color when it is active or not
{
    document.getElementById('inputTextArea').style.backgroundColor = '#FFFFFF';
    document.getElementById('instancesTextAreaID').style.backgroundColor ='#FFFFFF';

}


function blur() //to change color when it is active or not
{
 document.getElementById('inputTextArea').style.backgroundColor = '#d2d2d2'; //'#D4D2D2'; //'#E7E7E7';
 document.getElementById('instancesTextAreaID').style.backgroundColor ='#d2d2d2';
}

function setup()
{



    if (window.widget)
		{
		//document.getElementById('inputTextArea').focus();
		loadPreferences();
		}
	return 0;
}


function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}


function hideBack()
{
	//the following line is needed to hide the preferences from the preferenceslocation ID from the back side.
	//however I have NO IDEA wy I need to put in the bogus blank table information, but for some reason it seems to require it to work.
	document.getElementById('preferencesLocation').innerHTML= "<table border='0' cellpadding='0' cellspacing='0' width='130'></table>";
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
        
    if (window.widget)
    	savePreferences();
}


var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}

function open_homepage() {
	widget.openURL("http://www.supermagnus.com/")
}











<!--get the settings for the preferences -->

function getCharacterCountPreference()
	{
	return document.hiddenForm.characterSpacePreferenceHidden.value;	
	}

function getWordLengthPreference()
	{
	return document.hiddenForm.wordLengthPreferenceHidden.value;
	}

function getWordLengthNumberPreference()
	{
	return document.hiddenForm.wordLengthNumberHidden.value;
	}

function getHyphenatedWordsPreference()
	{
	return document.hiddenForm.hyphenatedWordsPreferenceHidden.value;
	}

function getCaseSensitiveSearchPreference()
	{
	return document.hiddenForm.caseSensitiveSearchPreferenceHidden.value;
	}







<!-- perform the character count -->

function getCharacterCount(textToCount)
	{
	var characterCount = 0;
	
	 textToCount = textToCount.replace(/\n/g,"");  //replace all returns with nothing since not really considered to be a character.

	
	
	if (getCharacterCountPreference() == true) //if should count ALL characters
		{
		characterCount = textToCount.length;
		}
	else
		{ //if should count characters without spaces 
		textToCount = textToCount.replace(/ /g, ""); //regular expression to replace all spaces globally with nothing
		textToCount = textToCount.replace(/	/g, ""); //regular expression to replace all tabs globally with nothing
		characterCount =textToCount.length;
		}
	return characterCount;
	}


<!-- perform the word count -->

function getWordCount(textToCount)
	{	
	if (textToCount.length <1) {return 0;} //if there is nothing on the screen typed in...
	
	//first do a few things to clean up the string a bit...
			
 	textToCount = textToCount.replace(/\n/g," ");  //replace all returns with spaces (since words are defined as having at least one space between each one).  and if two words are separated only by returns, then they would otherwise count as just one word.
	textToCount = textToCount.replace(/\t/g, " "); //so that tabs also separate words.
	textToCount = textToCount.replace(/--+/g, " "); //so that double dashes (or multiple dashes)between a word counts as two words, only a single hyphen should be a word...	
	textToCount = textToCount.replace(/ +/g, " "); //replace multiple spaces with only a single one.


	// for some reason in MS word, "<--" is 1 word but "-->" is two words ????????

	if (getHyphenatedWordsPreference() == 0) //1 = hyphenated words as one word, 0 = as separate words.
		{
			textToCount = textToCount.replace(/-/g, "- "); //add a space between hyphens to ensure that if it is between two words those words will count separately
		}

	textToCount = textToCount.replace(/^(\s+)?(.*\S)(\s+)?$/, '$2'); //trim white space 

	//if just doing full word count then...
	if (getWordLengthPreference() ==1 ) //1 = count words of all length
		{
		var tempArray = textToCount.split(" ");
		return tempArray.length;
		}
	else
		{
		//do complicated algorithm here....replace all relevant symbols with x's.
			//replace all single dashes between two words (letters)
		textToCount=textToCount.replace(/[a-zA-z]-[a-zA-z]/g, "xxx");
			//replace all single quotes between two words (letters)
		textToCount=textToCount.replace(/[a-zA-z]'[a-zA-z]/g, "xxx");
			//replace all dots betwen two numbers
		textToCount=textToCount.replace(/[0-9]\.[0-9]/g, "xxx");
			//replace all commas between two numbers
		textToCount=textToCount.replace(/[0-9],[0-9]/g, "xxx");
			//replace dollar signs if they are next to a number
		textToCount=textToCount.replace(/\$[0-9]/g, "xx");
				textToCount=textToCount.replace(/\$x/g, "xx");
			//finally, replace all alphanumerics with x's
		textToCount=textToCount.replace(/[a-zA-z0-9]/g, "x");
			//replace everything that is not an x with a space
		textToCount=textToCount.replace(/[^x]/g, " "); 

		var xstring = "";
		//make a string to represent the x string to replace:
		for (i=-1; i < (getWordLengthNumberPreference()) ; i=i+1)
			{
			xstring = xstring + "x";
			}
		var RegularExpression  =  new RegExp(xstring, "g"); //create regular expression with global flag form the string of x's
		//replace all strings that include the row of x's with a y
		textToCount = textToCount.replace(RegularExpression, "y"); //replace that string with y's
		textToCount = textToCount.replace(/x/g, ""); // remove all extra x's now.	
		textToCount = textToCount.replace(/ +/g, " "); //replace multiple spaces with only a single one.
		textToCount = textToCount.replace(/^(\s+)?(.*\S)(\s+)?$/, '$2'); //trim white space 
		var tempArray = textToCount.split (" "); //how many spaces are left
		return tempArray.length;
		}
	
						
//if here it means there must have been some problem 
return "Error"

return numToReturn;
	
	}











function countWords()
	{


	var textContents = document.getElementById('inputTextArea').value;
	
	var whichCountChosen = 	document.hiddenForm.countInstancesToggle.value;
	if (whichCountChosen ==1) //then do the normal word and character count
		{
		document.getElementById('words').innerHTML= "Words: " + getWordCount(textContents);
		document.getElementById('characters').innerHTML= "Characters: " + getCharacterCount(textContents);
		}
	else
		{
		countInstancesOfWord();
		}

	}
	
	
function loadPreferences()
	{
	document.hiddenForm.characterSpacePreferenceHidden.value = widget.preferenceForKey("characterCountPreference");
	document.hiddenForm.wordLengthPreferenceHidden.value = widget.preferenceForKey("wordLengthPreference");
	document.hiddenForm.wordLengthNumberHidden.value = widget.preferenceForKey("wordLengthNumberPreference");
	document.hiddenForm.hyphenatedWordsPreferenceHidden.value = widget.preferenceForKey("hyphenatedWordsPreference");
	document.hiddenForm.caseSensitiveSearchPreferenceHidden.value=widget.preferenceForKey("caseSensitiveSearchPreference");

	
	
	}
	
	
//preferences here
function savePreferences()
	{
    widget.setPreferenceForKey(getCharacterCountPreference(),"characterCountPreference");
    widget.setPreferenceForKey(getWordLengthPreference(), "wordLengthPreference");
    widget.setPreferenceForKey(getWordLengthNumberPreference(), "wordLengthNumberPreference");
    widget.setPreferenceForKey(getHyphenatedWordsPreference(), "hyphenatedWordsPreference");
    widget.setPreferenceForKey(getCaseSensitiveSearchPreference(), "caseSensitiveSearchPreference");
	}
	
	
	


function modifyWordLengthBox(booleanToUse)
	{
	if (booleanToUse)
		{
		document.getElementById('wordLengthNumber').disabled = false;
		}
	else
		{
		document.getElementById('wordLengthNumber').disabled = true;
		}
	}





	
function checkValidityOfNumber()
		{
		var booleanToReturn = true;
		var tempNum = document.getElementById('wordLengthNumber').value;
        var tempMod = tempNum % 1;
        if (tempMod == 0) 
         	{
        	booleanToReturn= true;
         	} 
        else 
        	{
            booleanToReturn= false;
            }
        
        if (tempNum < 1)
        	{document.getElementById('wordLengthNumber').value=3;}
        
		if (booleanToReturn ==false)
			{
			document.getElementById('wordLengthNumber').value=3;
			}
		}
	
function showCharacterCountPreference()
	{
	var checked1 = "";
	var checked2 = "";
	if (document.hiddenForm.characterSpacePreferenceHidden.value == 1)
		{checked1=" checked ";}
	else
		{checked2=" checked ";}
		document.getElementById('preferencesLocation').innerHTML= "" + 
		"<table border='0' cellpadding='2' cellspacing='2' width='130''>" +
		"<tr><td colspan='2'><center><b>Character Counts</b></center></td></tr>" +
		"<tr><td width='20'><input type='radio' name='characterSpacesPreference' " + checked1 + " onClick='updateCharacterSpacePreference(1);'></td><td>with spaces</td></tr>" +
		"<tr><td width='20'><input type='radio' name='characterSpacesPreference' " + checked2 + " onClick='updateCharacterSpacePreference(0);'><td>without spaces</td></tr>" +
		"</table>";

	}
		


function showWordCountPreference()
	{
	var checked1 = "";
	var checked2 = "";
	var disabled = "";
	var numberForBox = document.hiddenForm.wordLengthNumberHidden.value;
	if (document.hiddenForm.wordLengthPreferenceHidden.value == 1)
		{checked1=" checked ";  disabled=" disabled ";}
	else
		{checked2=" checked ";}
	
		document.getElementById('preferencesLocation').innerHTML= "" + 
		"<table border='0' cellpadding='2' cellspacing='2' width='130'>" +
		"<tr><td colspan='2'><center><b>Word Counts</b></center></td></tr>" +
		"<tr><td  width='20'><input type='radio' name='wordLengthPreference' " + checked1 + " onClick='updateWordLengthPreference(1);'></td><td>all words</td></tr>" +
		"<tr style='white-space:nowrap;'><td  width='20'><input type='radio' name='wordLengthPreference'  " + checked2 + " onClick='updateWordLengthPreference(0);'>&nbsp;<td>words > <input style='font-family:Lucida Grande;font-size:10px;color:black;text-align:center;' type='text' size='2' name='wordLengthNumber' id='wordLengthNumber' value='" + numberForBox + "' " + disabled + "onBlur='updateWordLengthNumberPreference();'/> chars</td></tr>" +
		"</table>";

	}	


function showHyphenatedWordsPreference()
	{
	var checked1 = "";
	var checked2 = "";
	if (document.hiddenForm.hyphenatedWordsPreferenceHidden.value == 1)
		{checked1=" checked ";}
	else
		{checked2=" checked ";}
		document.getElementById('preferencesLocation').innerHTML= "" + 
		"<table border='0' cellpadding='2' cellspacing='2' width='130'>" +
		"<tr><td colspan='2'><center><b>Hyphenated Words</b></center></td></tr>" +
		"<tr><td  width='20'><input type='radio' name='hyphenatedWordsPreference' " + checked1 + " onClick='updateHyphenatedWordsPreference(1);'></td><td>count as one word</td></tr>" +
		"<tr><td  width='20'><input type='radio' name='hyphenatedWordsPreference' " + checked2 + " onClick='updateHyphenatedWordsPreference(0);'><td>count as separate words</td></tr>" +
		"</table>";

	}	





function showCaseSensitiveSearchPreference()
	{
	var checked1 = "";
	var checked2 = "";
	if (document.hiddenForm.caseSensitiveSearchPreferenceHidden.value == 1)
		{checked1=" checked ";}
	else
		{checked2=" checked ";}
		document.getElementById('preferencesLocation').innerHTML= "" + 
		"<table border='0' cellpadding='2' cellspacing='2' width='130'>" +
		"<tr><td colspan='2'><center><b>Count Text Instances</b></center></td></tr>" +
		"<tr><td  width='20'><input type='radio' name='caseSensitiveSearchPreference' " + checked1 + " onClick='updateCaseSensitiveSearchPreference(1);'></td><td>case insensitive</td></tr>" +
		"<tr><td  width='20'><input type='radio' name='caseSensitiveSearchPreference' " + checked2 + " onClick='updateCaseSensitiveSearchPreference(0);'><td>case sensitive</td></tr>" +
		"</table>";

	}	






	
/***********************************************************************
The following function are used to update the hidden preferences based
on when the user changes the preferences in the changing div area for
preferences
************************************************************************/
	
function updateCharacterSpacePreference(num)
	{
	if (num == 1)
		{
		document.hiddenForm.characterSpacePreferenceHidden.value=1;
		}
	else
		{
		document.hiddenForm.characterSpacePreferenceHidden.value=0;
		}
	}
	
	
	

function updateWordLengthPreference(num)
	{
	if (num == 1)
		{
		modifyWordLengthBox(false);
		document.hiddenForm.wordLengthPreferenceHidden.value=1;
		}
	else
		{
		modifyWordLengthBox(true);
		document.hiddenForm.wordLengthPreferenceHidden.value=0;
		}
	}
	
	
function updateWordLengthNumberPreference()
	{
	checkValidityOfNumber();
	document.hiddenForm.wordLengthNumberHidden.value =  document.preferencesForm.wordLengthNumber.value;
	}
	
	
	
function updateHyphenatedWordsPreference(num)
	{
	if (num == 1)
		{
		document.hiddenForm.hyphenatedWordsPreferenceHidden.value=1;
		}
	else
		{
		document.hiddenForm.hyphenatedWordsPreferenceHidden.value=0;
		}
	}
	
	

function updateCaseSensitiveSearchPreference(num)
	{
	if (num == 1)
		{
		document.hiddenForm.caseSensitiveSearchPreferenceHidden.value=1;
		}
	else
		{
		document.hiddenForm.caseSensitiveSearchPreferenceHidden.value=0;
		}
	}
		

	
	
	
function countInstancesOfWord() 
	{

	
	
	var substringText = document.getElementById('instancesTextAreaID').value;
	var textToSearch = document.getElementById('inputTextArea').value;
	

	if (document.hiddenForm.caseSensitiveSearchPreferenceHidden.value==1)
		{
		substringText=substringText.toLowerCase();
		textToSearch=textToSearch.toLowerCase();
		}
	
	var substringArray= textToSearch.split(substringText);
	var numResult = substringArray.length -1;

	if (substringText == "" || textToSearch == "")
		{numResult = 0;}

	var wordText = "s";
	if (numResult == 1)
		{wordText = "";}
	
  document.getElementById('instancesResultsID').innerHTML=numResult + " instance" + wordText + " found";
 }
	
	
	
function showCountInstances()
	{
	document.getElementById('instancesTextID').style.visibility='visible';

	document.hiddenForm.countInstancesToggle.value='0'
	document.getElementById('instancesResultsID').style.visibility='visible';

	document.getElementById('words').style.visibility='hidden';
	document.getElementById('characters').style.visibility='hidden';

	document.getElementById('plusButtonId').innerHTML= "<img src='Images/minusButton.png' name='minusButtonImage' border='0' onClick=\"hideCountInstances();\"  onmousedown=\"document.minusButtonImage.src='Images/minusButtonDarker.png';\"  onmouseup=\"document.minusButtonImage.src='Images/minusButton.png';\"  onmouseout=\"document.minusButtonImage.src='Images/minusButton.png';\" title=\"Hide option to count instances of a word\"/>";
	
	}
	
function hideCountInstances()
	{
	document.hiddenForm.countInstancesToggle.value='1'

	document.getElementById('instancesTextID').style.visibility='hidden';
	document.getElementById('plusButtonId').innerHTML= "<img name='plusButtonImage'  src='Images/plusButton.png' border='0' onClick=\"showCountInstances();\"  onmousedown=\"document.plusButtonImage.src='Images/plusButtonDarker.png';\" onmouseup=\"document.plusButtonImage.src='Images/plusButton.png';\" onmouseout=\"document.plusButtonImage.src='Images/plusButton.png';\" title=\"Show option to count instances of a word\"/>";
	document.getElementById('words').style.visibility='visible';
	document.getElementById('characters').style.visibility='visible';
	document.getElementById('instancesResultsID').style.visibility='hidden';
	

	}


//the clearAll function was added on December 5, 2005 as per the request of a user	
function clearAll()
	{
	document.getElementById('words').innerHTML= "";
	document.getElementById('characters').innerHTML= "";
	document.getElementById('instancesResultsID').style.visibility='visible';
	document.getElementById('instancesResultsID').innerHTML="";
	document.getElementById('inputTextArea').value="";
	document.getElementById('instancesTextAreaID').value="";
	}


//this function works with the instance text area.  It strips out line feeds if the user
//presses return and makes the text stay visible in the small area instead of scrolling upwards
//due to the return.
//It also detects the return and activates the function to count the instances if the last
//character pressed in the instance text area box was a return character
function limitTextLength()
	{
	var tempText = document.getElementById('instancesTextAreaID').value;
	
	//just do a live count of instances
	var returnFound = true;
	
	
	//var returnFound = false;
	/*
	if (tempText.charAt((tempText.length) -1) == '\n')
		{returnFound = true;}
	
	if (tempText.charAt((tempText.length) -1) == '\r')
		{returnFound = true;}
	*/
	
	var tempText = tempText.replace(/\n/g, "");
	var tempText = tempText.replace(/\r/g, "");

	document.getElementById('instancesTextAreaID').value = tempText;
	
	if (returnFound)
		{countInstancesOfWord();
		}
	}
	


function pasteClipboardText()
	{	
	var clipboardText = widget.system("/usr/bin/osascript -e 'return (the clipboard)'", null).outputString;
	document.getElementById('inputTextArea').value = clipboardText;
	countWords();
	}